import * as $protobuf from "protobufjs";
import Long = require("long");
/** Namespace example. */
export namespace example {

    /** Properties of a Command. */
    interface ICommand {

        /** Command version */
        version?: (number|null);

        /** Command type */
        type?: (example.Command.Type|null);

        /** Command sentAt */
        sentAt?: (google.protobuf.ITimestamp|null);

        /** Command message */
        message?: (string|null);
    }

    /** Represents a Command. */
    class Command implements ICommand {

        /**
         * Constructs a new Command.
         * @param [properties] Properties to set
         */
        constructor(properties?: example.ICommand);

        /** Command version. */
        public version: number;

        /** Command type. */
        public type: example.Command.Type;

        /** Command sentAt. */
        public sentAt?: (google.protobuf.ITimestamp|null);

        /** Command message. */
        public message: string;

        /**
         * Creates a new Command instance using the specified properties.
         * @param [properties] Properties to set
         * @returns Command instance
         */
        public static create(properties?: example.ICommand): example.Command;

        /**
         * Encodes the specified Command message. Does not implicitly {@link example.Command.verify|verify} messages.
         * @param message Command message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encode(message: example.ICommand, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Encodes the specified Command message, length delimited. Does not implicitly {@link example.Command.verify|verify} messages.
         * @param message Command message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encodeDelimited(message: example.ICommand, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Decodes a Command message from the specified reader or buffer.
         * @param reader Reader or buffer to decode from
         * @param [length] Message length if known beforehand
         * @returns Command
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): example.Command;

        /**
         * Decodes a Command message from the specified reader or buffer, length delimited.
         * @param reader Reader or buffer to decode from
         * @returns Command
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decodeDelimited(reader: ($protobuf.Reader|Uint8Array)): example.Command;

        /**
         * Verifies a Command message.
         * @param message Plain object to verify
         * @returns `null` if valid, otherwise the reason why it is not
         */
        public static verify(message: { [k: string]: any }): (string|null);

        /**
         * Creates a Command message from a plain object. Also converts values to their respective internal types.
         * @param object Plain object
         * @returns Command
         */
        public static fromObject(object: { [k: string]: any }): example.Command;

        /**
         * Creates a plain object from a Command message. Also converts values to other types if specified.
         * @param message Command
         * @param [options] Conversion options
         * @returns Plain object
         */
        public static toObject(message: example.Command, options?: $protobuf.IConversionOptions): { [k: string]: any };

        /**
         * Converts this Command to JSON.
         * @returns JSON object
         */
        public toJSON(): { [k: string]: any };

        /**
         * Gets the default type url for Command
         * @param [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
         * @returns The default type url
         */
        public static getTypeUrl(typeUrlPrefix?: string): string;
    }

    namespace Command {

        /** Type enum. */
        enum Type {
            LOG = 0,
            READY = 1
        }
    }

    /** Properties of a Fibonacci. */
    interface IFibonacci {

        /** Fibonacci version */
        version?: (number|null);

        /** Fibonacci secondToLast */
        secondToLast?: (number|Long|null);

        /** Fibonacci last */
        last?: (number|Long|null);
    }

    /** Represents a Fibonacci. */
    class Fibonacci implements IFibonacci {

        /**
         * Constructs a new Fibonacci.
         * @param [properties] Properties to set
         */
        constructor(properties?: example.IFibonacci);

        /** Fibonacci version. */
        public version: number;

        /** Fibonacci secondToLast. */
        public secondToLast: (number|Long);

        /** Fibonacci last. */
        public last: (number|Long);

        /**
         * Creates a new Fibonacci instance using the specified properties.
         * @param [properties] Properties to set
         * @returns Fibonacci instance
         */
        public static create(properties?: example.IFibonacci): example.Fibonacci;

        /**
         * Encodes the specified Fibonacci message. Does not implicitly {@link example.Fibonacci.verify|verify} messages.
         * @param message Fibonacci message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encode(message: example.IFibonacci, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Encodes the specified Fibonacci message, length delimited. Does not implicitly {@link example.Fibonacci.verify|verify} messages.
         * @param message Fibonacci message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encodeDelimited(message: example.IFibonacci, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Decodes a Fibonacci message from the specified reader or buffer.
         * @param reader Reader or buffer to decode from
         * @param [length] Message length if known beforehand
         * @returns Fibonacci
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): example.Fibonacci;

        /**
         * Decodes a Fibonacci message from the specified reader or buffer, length delimited.
         * @param reader Reader or buffer to decode from
         * @returns Fibonacci
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decodeDelimited(reader: ($protobuf.Reader|Uint8Array)): example.Fibonacci;

        /**
         * Verifies a Fibonacci message.
         * @param message Plain object to verify
         * @returns `null` if valid, otherwise the reason why it is not
         */
        public static verify(message: { [k: string]: any }): (string|null);

        /**
         * Creates a Fibonacci message from a plain object. Also converts values to their respective internal types.
         * @param object Plain object
         * @returns Fibonacci
         */
        public static fromObject(object: { [k: string]: any }): example.Fibonacci;

        /**
         * Creates a plain object from a Fibonacci message. Also converts values to other types if specified.
         * @param message Fibonacci
         * @param [options] Conversion options
         * @returns Plain object
         */
        public static toObject(message: example.Fibonacci, options?: $protobuf.IConversionOptions): { [k: string]: any };

        /**
         * Converts this Fibonacci to JSON.
         * @returns JSON object
         */
        public toJSON(): { [k: string]: any };

        /**
         * Gets the default type url for Fibonacci
         * @param [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
         * @returns The default type url
         */
        public static getTypeUrl(typeUrlPrefix?: string): string;
    }

    /** Properties of a FocusChange. */
    interface IFocusChange {

        /** FocusChange version */
        version?: (number|null);

        /** FocusChange state */
        state?: (example.FocusChange.State|null);
    }

    /** Represents a FocusChange. */
    class FocusChange implements IFocusChange {

        /**
         * Constructs a new FocusChange.
         * @param [properties] Properties to set
         */
        constructor(properties?: example.IFocusChange);

        /** FocusChange version. */
        public version: number;

        /** FocusChange state. */
        public state: example.FocusChange.State;

        /**
         * Creates a new FocusChange instance using the specified properties.
         * @param [properties] Properties to set
         * @returns FocusChange instance
         */
        public static create(properties?: example.IFocusChange): example.FocusChange;

        /**
         * Encodes the specified FocusChange message. Does not implicitly {@link example.FocusChange.verify|verify} messages.
         * @param message FocusChange message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encode(message: example.IFocusChange, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Encodes the specified FocusChange message, length delimited. Does not implicitly {@link example.FocusChange.verify|verify} messages.
         * @param message FocusChange message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encodeDelimited(message: example.IFocusChange, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Decodes a FocusChange message from the specified reader or buffer.
         * @param reader Reader or buffer to decode from
         * @param [length] Message length if known beforehand
         * @returns FocusChange
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): example.FocusChange;

        /**
         * Decodes a FocusChange message from the specified reader or buffer, length delimited.
         * @param reader Reader or buffer to decode from
         * @returns FocusChange
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decodeDelimited(reader: ($protobuf.Reader|Uint8Array)): example.FocusChange;

        /**
         * Verifies a FocusChange message.
         * @param message Plain object to verify
         * @returns `null` if valid, otherwise the reason why it is not
         */
        public static verify(message: { [k: string]: any }): (string|null);

        /**
         * Creates a FocusChange message from a plain object. Also converts values to their respective internal types.
         * @param object Plain object
         * @returns FocusChange
         */
        public static fromObject(object: { [k: string]: any }): example.FocusChange;

        /**
         * Creates a plain object from a FocusChange message. Also converts values to other types if specified.
         * @param message FocusChange
         * @param [options] Conversion options
         * @returns Plain object
         */
        public static toObject(message: example.FocusChange, options?: $protobuf.IConversionOptions): { [k: string]: any };

        /**
         * Converts this FocusChange to JSON.
         * @returns JSON object
         */
        public toJSON(): { [k: string]: any };

        /**
         * Gets the default type url for FocusChange
         * @param [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
         * @returns The default type url
         */
        public static getTypeUrl(typeUrlPrefix?: string): string;
    }

    namespace FocusChange {

        /** State enum. */
        enum State {
            FOCUSED = 0,
            BLURRED = 1
        }
    }
}

/** Namespace google. */
export namespace google {

    /** Namespace protobuf. */
    namespace protobuf {

        /** Properties of a Timestamp. */
        interface ITimestamp {

            /** Timestamp seconds */
            seconds?: (number|Long|null);

            /** Timestamp nanos */
            nanos?: (number|null);
        }

        /** Represents a Timestamp. */
        class Timestamp implements ITimestamp {

            /**
             * Constructs a new Timestamp.
             * @param [properties] Properties to set
             */
            constructor(properties?: google.protobuf.ITimestamp);

            /** Timestamp seconds. */
            public seconds: (number|Long);

            /** Timestamp nanos. */
            public nanos: number;

            /**
             * Creates a new Timestamp instance using the specified properties.
             * @param [properties] Properties to set
             * @returns Timestamp instance
             */
            public static create(properties?: google.protobuf.ITimestamp): google.protobuf.Timestamp;

            /**
             * Encodes the specified Timestamp message. Does not implicitly {@link google.protobuf.Timestamp.verify|verify} messages.
             * @param message Timestamp message or plain object to encode
             * @param [writer] Writer to encode to
             * @returns Writer
             */
            public static encode(message: google.protobuf.ITimestamp, writer?: $protobuf.Writer): $protobuf.Writer;

            /**
             * Encodes the specified Timestamp message, length delimited. Does not implicitly {@link google.protobuf.Timestamp.verify|verify} messages.
             * @param message Timestamp message or plain object to encode
             * @param [writer] Writer to encode to
             * @returns Writer
             */
            public static encodeDelimited(message: google.protobuf.ITimestamp, writer?: $protobuf.Writer): $protobuf.Writer;

            /**
             * Decodes a Timestamp message from the specified reader or buffer.
             * @param reader Reader or buffer to decode from
             * @param [length] Message length if known beforehand
             * @returns Timestamp
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): google.protobuf.Timestamp;

            /**
             * Decodes a Timestamp message from the specified reader or buffer, length delimited.
             * @param reader Reader or buffer to decode from
             * @returns Timestamp
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            public static decodeDelimited(reader: ($protobuf.Reader|Uint8Array)): google.protobuf.Timestamp;

            /**
             * Verifies a Timestamp message.
             * @param message Plain object to verify
             * @returns `null` if valid, otherwise the reason why it is not
             */
            public static verify(message: { [k: string]: any }): (string|null);

            /**
             * Creates a Timestamp message from a plain object. Also converts values to their respective internal types.
             * @param object Plain object
             * @returns Timestamp
             */
            public static fromObject(object: { [k: string]: any }): google.protobuf.Timestamp;

            /**
             * Creates a plain object from a Timestamp message. Also converts values to other types if specified.
             * @param message Timestamp
             * @param [options] Conversion options
             * @returns Plain object
             */
            public static toObject(message: google.protobuf.Timestamp, options?: $protobuf.IConversionOptions): { [k: string]: any };

            /**
             * Converts this Timestamp to JSON.
             * @returns JSON object
             */
            public toJSON(): { [k: string]: any };

            /**
             * Gets the default type url for Timestamp
             * @param [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
             * @returns The default type url
             */
            public static getTypeUrl(typeUrlPrefix?: string): string;
        }
    }
}
