/*eslint-disable block-scoped-var, id-length, no-control-regex, no-magic-numbers, no-prototype-builtins, no-redeclare, no-shadow, no-var, sort-vars*/
import * as $protobuf from "protobufjs/minimal";

// Common aliases
const $Reader = $protobuf.Reader, $Writer = $protobuf.Writer, $util = $protobuf.util;

// Exported root namespace
const $root = $protobuf.roots["default"] || ($protobuf.roots["default"] = {});

export const example = $root.example = (() => {

    /**
     * Namespace example.
     * @exports example
     * @namespace
     */
    const example = {};

    example.Command = (function() {

        /**
         * Properties of a Command.
         * @memberof example
         * @interface ICommand
         * @property {number|null} [version] Command version
         * @property {example.Command.Type|null} [type] Command type
         * @property {google.protobuf.ITimestamp|null} [sentAt] Command sentAt
         * @property {string|null} [message] Command message
         */

        /**
         * Constructs a new Command.
         * @memberof example
         * @classdesc Represents a Command.
         * @implements ICommand
         * @constructor
         * @param {example.ICommand=} [properties] Properties to set
         */
        function Command(properties) {
            if (properties)
                for (let keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * Command version.
         * @member {number} version
         * @memberof example.Command
         * @instance
         */
        Command.prototype.version = 0;

        /**
         * Command type.
         * @member {example.Command.Type} type
         * @memberof example.Command
         * @instance
         */
        Command.prototype.type = 0;

        /**
         * Command sentAt.
         * @member {google.protobuf.ITimestamp|null|undefined} sentAt
         * @memberof example.Command
         * @instance
         */
        Command.prototype.sentAt = null;

        /**
         * Command message.
         * @member {string} message
         * @memberof example.Command
         * @instance
         */
        Command.prototype.message = "";

        /**
         * Creates a new Command instance using the specified properties.
         * @function create
         * @memberof example.Command
         * @static
         * @param {example.ICommand=} [properties] Properties to set
         * @returns {example.Command} Command instance
         */
        Command.create = function create(properties) {
            return new Command(properties);
        };

        /**
         * Encodes the specified Command message. Does not implicitly {@link example.Command.verify|verify} messages.
         * @function encode
         * @memberof example.Command
         * @static
         * @param {example.ICommand} message Command message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        Command.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.version != null && Object.hasOwnProperty.call(message, "version"))
                writer.uint32(/* id 1, wireType 0 =*/8).uint32(message.version);
            if (message.type != null && Object.hasOwnProperty.call(message, "type"))
                writer.uint32(/* id 2, wireType 0 =*/16).int32(message.type);
            if (message.sentAt != null && Object.hasOwnProperty.call(message, "sentAt"))
                $root.google.protobuf.Timestamp.encode(message.sentAt, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
            if (message.message != null && Object.hasOwnProperty.call(message, "message"))
                writer.uint32(/* id 4, wireType 2 =*/34).string(message.message);
            return writer;
        };

        /**
         * Encodes the specified Command message, length delimited. Does not implicitly {@link example.Command.verify|verify} messages.
         * @function encodeDelimited
         * @memberof example.Command
         * @static
         * @param {example.ICommand} message Command message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        Command.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a Command message from the specified reader or buffer.
         * @function decode
         * @memberof example.Command
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {example.Command} Command
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        Command.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            let end = length === undefined ? reader.len : reader.pos + length, message = new $root.example.Command();
            while (reader.pos < end) {
                let tag = reader.uint32();
                switch (tag >>> 3) {
                case 1: {
                        message.version = reader.uint32();
                        break;
                    }
                case 2: {
                        message.type = reader.int32();
                        break;
                    }
                case 3: {
                        message.sentAt = $root.google.protobuf.Timestamp.decode(reader, reader.uint32());
                        break;
                    }
                case 4: {
                        message.message = reader.string();
                        break;
                    }
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a Command message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof example.Command
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {example.Command} Command
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        Command.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a Command message.
         * @function verify
         * @memberof example.Command
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        Command.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.version != null && message.hasOwnProperty("version"))
                if (!$util.isInteger(message.version))
                    return "version: integer expected";
            if (message.type != null && message.hasOwnProperty("type"))
                switch (message.type) {
                default:
                    return "type: enum value expected";
                case 0:
                case 1:
                    break;
                }
            if (message.sentAt != null && message.hasOwnProperty("sentAt")) {
                let error = $root.google.protobuf.Timestamp.verify(message.sentAt);
                if (error)
                    return "sentAt." + error;
            }
            if (message.message != null && message.hasOwnProperty("message"))
                if (!$util.isString(message.message))
                    return "message: string expected";
            return null;
        };

        /**
         * Creates a Command message from a plain object. Also converts values to their respective internal types.
         * @function fromObject
         * @memberof example.Command
         * @static
         * @param {Object.<string,*>} object Plain object
         * @returns {example.Command} Command
         */
        Command.fromObject = function fromObject(object) {
            if (object instanceof $root.example.Command)
                return object;
            let message = new $root.example.Command();
            if (object.version != null)
                message.version = object.version >>> 0;
            switch (object.type) {
            default:
                if (typeof object.type === "number") {
                    message.type = object.type;
                    break;
                }
                break;
            case "LOG":
            case 0:
                message.type = 0;
                break;
            case "READY":
            case 1:
                message.type = 1;
                break;
            }
            if (object.sentAt != null) {
                if (typeof object.sentAt !== "object")
                    throw TypeError(".example.Command.sentAt: object expected");
                message.sentAt = $root.google.protobuf.Timestamp.fromObject(object.sentAt);
            }
            if (object.message != null)
                message.message = String(object.message);
            return message;
        };

        /**
         * Creates a plain object from a Command message. Also converts values to other types if specified.
         * @function toObject
         * @memberof example.Command
         * @static
         * @param {example.Command} message Command
         * @param {$protobuf.IConversionOptions} [options] Conversion options
         * @returns {Object.<string,*>} Plain object
         */
        Command.toObject = function toObject(message, options) {
            if (!options)
                options = {};
            let object = {};
            if (options.defaults) {
                object.version = 0;
                object.type = options.enums === String ? "LOG" : 0;
                object.sentAt = null;
                object.message = "";
            }
            if (message.version != null && message.hasOwnProperty("version"))
                object.version = message.version;
            if (message.type != null && message.hasOwnProperty("type"))
                object.type = options.enums === String ? $root.example.Command.Type[message.type] === undefined ? message.type : $root.example.Command.Type[message.type] : message.type;
            if (message.sentAt != null && message.hasOwnProperty("sentAt"))
                object.sentAt = $root.google.protobuf.Timestamp.toObject(message.sentAt, options);
            if (message.message != null && message.hasOwnProperty("message"))
                object.message = message.message;
            return object;
        };

        /**
         * Converts this Command to JSON.
         * @function toJSON
         * @memberof example.Command
         * @instance
         * @returns {Object.<string,*>} JSON object
         */
        Command.prototype.toJSON = function toJSON() {
            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
        };

        /**
         * Gets the default type url for Command
         * @function getTypeUrl
         * @memberof example.Command
         * @static
         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
         * @returns {string} The default type url
         */
        Command.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
            if (typeUrlPrefix === undefined) {
                typeUrlPrefix = "type.googleapis.com";
            }
            return typeUrlPrefix + "/example.Command";
        };

        /**
         * Type enum.
         * @name example.Command.Type
         * @enum {number}
         * @property {number} LOG=0 LOG value
         * @property {number} READY=1 READY value
         */
        Command.Type = (function() {
            const valuesById = {}, values = Object.create(valuesById);
            values[valuesById[0] = "LOG"] = 0;
            values[valuesById[1] = "READY"] = 1;
            return values;
        })();

        return Command;
    })();

    example.Fibonacci = (function() {

        /**
         * Properties of a Fibonacci.
         * @memberof example
         * @interface IFibonacci
         * @property {number|null} [version] Fibonacci version
         * @property {number|Long|null} [secondToLast] Fibonacci secondToLast
         * @property {number|Long|null} [last] Fibonacci last
         */

        /**
         * Constructs a new Fibonacci.
         * @memberof example
         * @classdesc Represents a Fibonacci.
         * @implements IFibonacci
         * @constructor
         * @param {example.IFibonacci=} [properties] Properties to set
         */
        function Fibonacci(properties) {
            if (properties)
                for (let keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * Fibonacci version.
         * @member {number} version
         * @memberof example.Fibonacci
         * @instance
         */
        Fibonacci.prototype.version = 0;

        /**
         * Fibonacci secondToLast.
         * @member {number|Long} secondToLast
         * @memberof example.Fibonacci
         * @instance
         */
        Fibonacci.prototype.secondToLast = $util.Long ? $util.Long.fromBits(0,0,false) : 0;

        /**
         * Fibonacci last.
         * @member {number|Long} last
         * @memberof example.Fibonacci
         * @instance
         */
        Fibonacci.prototype.last = $util.Long ? $util.Long.fromBits(0,0,false) : 0;

        /**
         * Creates a new Fibonacci instance using the specified properties.
         * @function create
         * @memberof example.Fibonacci
         * @static
         * @param {example.IFibonacci=} [properties] Properties to set
         * @returns {example.Fibonacci} Fibonacci instance
         */
        Fibonacci.create = function create(properties) {
            return new Fibonacci(properties);
        };

        /**
         * Encodes the specified Fibonacci message. Does not implicitly {@link example.Fibonacci.verify|verify} messages.
         * @function encode
         * @memberof example.Fibonacci
         * @static
         * @param {example.IFibonacci} message Fibonacci message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        Fibonacci.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.version != null && Object.hasOwnProperty.call(message, "version"))
                writer.uint32(/* id 1, wireType 0 =*/8).uint32(message.version);
            if (message.secondToLast != null && Object.hasOwnProperty.call(message, "secondToLast"))
                writer.uint32(/* id 2, wireType 0 =*/16).int64(message.secondToLast);
            if (message.last != null && Object.hasOwnProperty.call(message, "last"))
                writer.uint32(/* id 3, wireType 0 =*/24).int64(message.last);
            return writer;
        };

        /**
         * Encodes the specified Fibonacci message, length delimited. Does not implicitly {@link example.Fibonacci.verify|verify} messages.
         * @function encodeDelimited
         * @memberof example.Fibonacci
         * @static
         * @param {example.IFibonacci} message Fibonacci message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        Fibonacci.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a Fibonacci message from the specified reader or buffer.
         * @function decode
         * @memberof example.Fibonacci
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {example.Fibonacci} Fibonacci
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        Fibonacci.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            let end = length === undefined ? reader.len : reader.pos + length, message = new $root.example.Fibonacci();
            while (reader.pos < end) {
                let tag = reader.uint32();
                switch (tag >>> 3) {
                case 1: {
                        message.version = reader.uint32();
                        break;
                    }
                case 2: {
                        message.secondToLast = reader.int64();
                        break;
                    }
                case 3: {
                        message.last = reader.int64();
                        break;
                    }
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a Fibonacci message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof example.Fibonacci
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {example.Fibonacci} Fibonacci
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        Fibonacci.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a Fibonacci message.
         * @function verify
         * @memberof example.Fibonacci
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        Fibonacci.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.version != null && message.hasOwnProperty("version"))
                if (!$util.isInteger(message.version))
                    return "version: integer expected";
            if (message.secondToLast != null && message.hasOwnProperty("secondToLast"))
                if (!$util.isInteger(message.secondToLast) && !(message.secondToLast && $util.isInteger(message.secondToLast.low) && $util.isInteger(message.secondToLast.high)))
                    return "secondToLast: integer|Long expected";
            if (message.last != null && message.hasOwnProperty("last"))
                if (!$util.isInteger(message.last) && !(message.last && $util.isInteger(message.last.low) && $util.isInteger(message.last.high)))
                    return "last: integer|Long expected";
            return null;
        };

        /**
         * Creates a Fibonacci message from a plain object. Also converts values to their respective internal types.
         * @function fromObject
         * @memberof example.Fibonacci
         * @static
         * @param {Object.<string,*>} object Plain object
         * @returns {example.Fibonacci} Fibonacci
         */
        Fibonacci.fromObject = function fromObject(object) {
            if (object instanceof $root.example.Fibonacci)
                return object;
            let message = new $root.example.Fibonacci();
            if (object.version != null)
                message.version = object.version >>> 0;
            if (object.secondToLast != null)
                if ($util.Long)
                    (message.secondToLast = $util.Long.fromValue(object.secondToLast)).unsigned = false;
                else if (typeof object.secondToLast === "string")
                    message.secondToLast = parseInt(object.secondToLast, 10);
                else if (typeof object.secondToLast === "number")
                    message.secondToLast = object.secondToLast;
                else if (typeof object.secondToLast === "object")
                    message.secondToLast = new $util.LongBits(object.secondToLast.low >>> 0, object.secondToLast.high >>> 0).toNumber();
            if (object.last != null)
                if ($util.Long)
                    (message.last = $util.Long.fromValue(object.last)).unsigned = false;
                else if (typeof object.last === "string")
                    message.last = parseInt(object.last, 10);
                else if (typeof object.last === "number")
                    message.last = object.last;
                else if (typeof object.last === "object")
                    message.last = new $util.LongBits(object.last.low >>> 0, object.last.high >>> 0).toNumber();
            return message;
        };

        /**
         * Creates a plain object from a Fibonacci message. Also converts values to other types if specified.
         * @function toObject
         * @memberof example.Fibonacci
         * @static
         * @param {example.Fibonacci} message Fibonacci
         * @param {$protobuf.IConversionOptions} [options] Conversion options
         * @returns {Object.<string,*>} Plain object
         */
        Fibonacci.toObject = function toObject(message, options) {
            if (!options)
                options = {};
            let object = {};
            if (options.defaults) {
                object.version = 0;
                if ($util.Long) {
                    let long = new $util.Long(0, 0, false);
                    object.secondToLast = options.longs === String ? long.toString() : options.longs === Number ? long.toNumber() : long;
                } else
                    object.secondToLast = options.longs === String ? "0" : 0;
                if ($util.Long) {
                    let long = new $util.Long(0, 0, false);
                    object.last = options.longs === String ? long.toString() : options.longs === Number ? long.toNumber() : long;
                } else
                    object.last = options.longs === String ? "0" : 0;
            }
            if (message.version != null && message.hasOwnProperty("version"))
                object.version = message.version;
            if (message.secondToLast != null && message.hasOwnProperty("secondToLast"))
                if (typeof message.secondToLast === "number")
                    object.secondToLast = options.longs === String ? String(message.secondToLast) : message.secondToLast;
                else
                    object.secondToLast = options.longs === String ? $util.Long.prototype.toString.call(message.secondToLast) : options.longs === Number ? new $util.LongBits(message.secondToLast.low >>> 0, message.secondToLast.high >>> 0).toNumber() : message.secondToLast;
            if (message.last != null && message.hasOwnProperty("last"))
                if (typeof message.last === "number")
                    object.last = options.longs === String ? String(message.last) : message.last;
                else
                    object.last = options.longs === String ? $util.Long.prototype.toString.call(message.last) : options.longs === Number ? new $util.LongBits(message.last.low >>> 0, message.last.high >>> 0).toNumber() : message.last;
            return object;
        };

        /**
         * Converts this Fibonacci to JSON.
         * @function toJSON
         * @memberof example.Fibonacci
         * @instance
         * @returns {Object.<string,*>} JSON object
         */
        Fibonacci.prototype.toJSON = function toJSON() {
            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
        };

        /**
         * Gets the default type url for Fibonacci
         * @function getTypeUrl
         * @memberof example.Fibonacci
         * @static
         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
         * @returns {string} The default type url
         */
        Fibonacci.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
            if (typeUrlPrefix === undefined) {
                typeUrlPrefix = "type.googleapis.com";
            }
            return typeUrlPrefix + "/example.Fibonacci";
        };

        return Fibonacci;
    })();

    example.FocusChange = (function() {

        /**
         * Properties of a FocusChange.
         * @memberof example
         * @interface IFocusChange
         * @property {number|null} [version] FocusChange version
         * @property {example.FocusChange.State|null} [state] FocusChange state
         */

        /**
         * Constructs a new FocusChange.
         * @memberof example
         * @classdesc Represents a FocusChange.
         * @implements IFocusChange
         * @constructor
         * @param {example.IFocusChange=} [properties] Properties to set
         */
        function FocusChange(properties) {
            if (properties)
                for (let keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * FocusChange version.
         * @member {number} version
         * @memberof example.FocusChange
         * @instance
         */
        FocusChange.prototype.version = 0;

        /**
         * FocusChange state.
         * @member {example.FocusChange.State} state
         * @memberof example.FocusChange
         * @instance
         */
        FocusChange.prototype.state = 0;

        /**
         * Creates a new FocusChange instance using the specified properties.
         * @function create
         * @memberof example.FocusChange
         * @static
         * @param {example.IFocusChange=} [properties] Properties to set
         * @returns {example.FocusChange} FocusChange instance
         */
        FocusChange.create = function create(properties) {
            return new FocusChange(properties);
        };

        /**
         * Encodes the specified FocusChange message. Does not implicitly {@link example.FocusChange.verify|verify} messages.
         * @function encode
         * @memberof example.FocusChange
         * @static
         * @param {example.IFocusChange} message FocusChange message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        FocusChange.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.version != null && Object.hasOwnProperty.call(message, "version"))
                writer.uint32(/* id 1, wireType 0 =*/8).uint32(message.version);
            if (message.state != null && Object.hasOwnProperty.call(message, "state"))
                writer.uint32(/* id 2, wireType 0 =*/16).int32(message.state);
            return writer;
        };

        /**
         * Encodes the specified FocusChange message, length delimited. Does not implicitly {@link example.FocusChange.verify|verify} messages.
         * @function encodeDelimited
         * @memberof example.FocusChange
         * @static
         * @param {example.IFocusChange} message FocusChange message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        FocusChange.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a FocusChange message from the specified reader or buffer.
         * @function decode
         * @memberof example.FocusChange
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {example.FocusChange} FocusChange
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        FocusChange.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            let end = length === undefined ? reader.len : reader.pos + length, message = new $root.example.FocusChange();
            while (reader.pos < end) {
                let tag = reader.uint32();
                switch (tag >>> 3) {
                case 1: {
                        message.version = reader.uint32();
                        break;
                    }
                case 2: {
                        message.state = reader.int32();
                        break;
                    }
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a FocusChange message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof example.FocusChange
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {example.FocusChange} FocusChange
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        FocusChange.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a FocusChange message.
         * @function verify
         * @memberof example.FocusChange
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        FocusChange.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.version != null && message.hasOwnProperty("version"))
                if (!$util.isInteger(message.version))
                    return "version: integer expected";
            if (message.state != null && message.hasOwnProperty("state"))
                switch (message.state) {
                default:
                    return "state: enum value expected";
                case 0:
                case 1:
                    break;
                }
            return null;
        };

        /**
         * Creates a FocusChange message from a plain object. Also converts values to their respective internal types.
         * @function fromObject
         * @memberof example.FocusChange
         * @static
         * @param {Object.<string,*>} object Plain object
         * @returns {example.FocusChange} FocusChange
         */
        FocusChange.fromObject = function fromObject(object) {
            if (object instanceof $root.example.FocusChange)
                return object;
            let message = new $root.example.FocusChange();
            if (object.version != null)
                message.version = object.version >>> 0;
            switch (object.state) {
            default:
                if (typeof object.state === "number") {
                    message.state = object.state;
                    break;
                }
                break;
            case "FOCUSED":
            case 0:
                message.state = 0;
                break;
            case "BLURRED":
            case 1:
                message.state = 1;
                break;
            }
            return message;
        };

        /**
         * Creates a plain object from a FocusChange message. Also converts values to other types if specified.
         * @function toObject
         * @memberof example.FocusChange
         * @static
         * @param {example.FocusChange} message FocusChange
         * @param {$protobuf.IConversionOptions} [options] Conversion options
         * @returns {Object.<string,*>} Plain object
         */
        FocusChange.toObject = function toObject(message, options) {
            if (!options)
                options = {};
            let object = {};
            if (options.defaults) {
                object.version = 0;
                object.state = options.enums === String ? "FOCUSED" : 0;
            }
            if (message.version != null && message.hasOwnProperty("version"))
                object.version = message.version;
            if (message.state != null && message.hasOwnProperty("state"))
                object.state = options.enums === String ? $root.example.FocusChange.State[message.state] === undefined ? message.state : $root.example.FocusChange.State[message.state] : message.state;
            return object;
        };

        /**
         * Converts this FocusChange to JSON.
         * @function toJSON
         * @memberof example.FocusChange
         * @instance
         * @returns {Object.<string,*>} JSON object
         */
        FocusChange.prototype.toJSON = function toJSON() {
            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
        };

        /**
         * Gets the default type url for FocusChange
         * @function getTypeUrl
         * @memberof example.FocusChange
         * @static
         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
         * @returns {string} The default type url
         */
        FocusChange.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
            if (typeUrlPrefix === undefined) {
                typeUrlPrefix = "type.googleapis.com";
            }
            return typeUrlPrefix + "/example.FocusChange";
        };

        /**
         * State enum.
         * @name example.FocusChange.State
         * @enum {number}
         * @property {number} FOCUSED=0 FOCUSED value
         * @property {number} BLURRED=1 BLURRED value
         */
        FocusChange.State = (function() {
            const valuesById = {}, values = Object.create(valuesById);
            values[valuesById[0] = "FOCUSED"] = 0;
            values[valuesById[1] = "BLURRED"] = 1;
            return values;
        })();

        return FocusChange;
    })();

    return example;
})();

export const google = $root.google = (() => {

    /**
     * Namespace google.
     * @exports google
     * @namespace
     */
    const google = {};

    google.protobuf = (function() {

        /**
         * Namespace protobuf.
         * @memberof google
         * @namespace
         */
        const protobuf = {};

        protobuf.Timestamp = (function() {

            /**
             * Properties of a Timestamp.
             * @memberof google.protobuf
             * @interface ITimestamp
             * @property {number|Long|null} [seconds] Timestamp seconds
             * @property {number|null} [nanos] Timestamp nanos
             */

            /**
             * Constructs a new Timestamp.
             * @memberof google.protobuf
             * @classdesc Represents a Timestamp.
             * @implements ITimestamp
             * @constructor
             * @param {google.protobuf.ITimestamp=} [properties] Properties to set
             */
            function Timestamp(properties) {
                if (properties)
                    for (let keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                        if (properties[keys[i]] != null)
                            this[keys[i]] = properties[keys[i]];
            }

            /**
             * Timestamp seconds.
             * @member {number|Long} seconds
             * @memberof google.protobuf.Timestamp
             * @instance
             */
            Timestamp.prototype.seconds = $util.Long ? $util.Long.fromBits(0,0,false) : 0;

            /**
             * Timestamp nanos.
             * @member {number} nanos
             * @memberof google.protobuf.Timestamp
             * @instance
             */
            Timestamp.prototype.nanos = 0;

            /**
             * Creates a new Timestamp instance using the specified properties.
             * @function create
             * @memberof google.protobuf.Timestamp
             * @static
             * @param {google.protobuf.ITimestamp=} [properties] Properties to set
             * @returns {google.protobuf.Timestamp} Timestamp instance
             */
            Timestamp.create = function create(properties) {
                return new Timestamp(properties);
            };

            /**
             * Encodes the specified Timestamp message. Does not implicitly {@link google.protobuf.Timestamp.verify|verify} messages.
             * @function encode
             * @memberof google.protobuf.Timestamp
             * @static
             * @param {google.protobuf.ITimestamp} message Timestamp message or plain object to encode
             * @param {$protobuf.Writer} [writer] Writer to encode to
             * @returns {$protobuf.Writer} Writer
             */
            Timestamp.encode = function encode(message, writer) {
                if (!writer)
                    writer = $Writer.create();
                if (message.seconds != null && Object.hasOwnProperty.call(message, "seconds"))
                    writer.uint32(/* id 1, wireType 0 =*/8).int64(message.seconds);
                if (message.nanos != null && Object.hasOwnProperty.call(message, "nanos"))
                    writer.uint32(/* id 2, wireType 0 =*/16).int32(message.nanos);
                return writer;
            };

            /**
             * Encodes the specified Timestamp message, length delimited. Does not implicitly {@link google.protobuf.Timestamp.verify|verify} messages.
             * @function encodeDelimited
             * @memberof google.protobuf.Timestamp
             * @static
             * @param {google.protobuf.ITimestamp} message Timestamp message or plain object to encode
             * @param {$protobuf.Writer} [writer] Writer to encode to
             * @returns {$protobuf.Writer} Writer
             */
            Timestamp.encodeDelimited = function encodeDelimited(message, writer) {
                return this.encode(message, writer).ldelim();
            };

            /**
             * Decodes a Timestamp message from the specified reader or buffer.
             * @function decode
             * @memberof google.protobuf.Timestamp
             * @static
             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
             * @param {number} [length] Message length if known beforehand
             * @returns {google.protobuf.Timestamp} Timestamp
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            Timestamp.decode = function decode(reader, length) {
                if (!(reader instanceof $Reader))
                    reader = $Reader.create(reader);
                let end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.protobuf.Timestamp();
                while (reader.pos < end) {
                    let tag = reader.uint32();
                    switch (tag >>> 3) {
                    case 1: {
                            message.seconds = reader.int64();
                            break;
                        }
                    case 2: {
                            message.nanos = reader.int32();
                            break;
                        }
                    default:
                        reader.skipType(tag & 7);
                        break;
                    }
                }
                return message;
            };

            /**
             * Decodes a Timestamp message from the specified reader or buffer, length delimited.
             * @function decodeDelimited
             * @memberof google.protobuf.Timestamp
             * @static
             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
             * @returns {google.protobuf.Timestamp} Timestamp
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            Timestamp.decodeDelimited = function decodeDelimited(reader) {
                if (!(reader instanceof $Reader))
                    reader = new $Reader(reader);
                return this.decode(reader, reader.uint32());
            };

            /**
             * Verifies a Timestamp message.
             * @function verify
             * @memberof google.protobuf.Timestamp
             * @static
             * @param {Object.<string,*>} message Plain object to verify
             * @returns {string|null} `null` if valid, otherwise the reason why it is not
             */
            Timestamp.verify = function verify(message) {
                if (typeof message !== "object" || message === null)
                    return "object expected";
                if (message.seconds != null && message.hasOwnProperty("seconds"))
                    if (!$util.isInteger(message.seconds) && !(message.seconds && $util.isInteger(message.seconds.low) && $util.isInteger(message.seconds.high)))
                        return "seconds: integer|Long expected";
                if (message.nanos != null && message.hasOwnProperty("nanos"))
                    if (!$util.isInteger(message.nanos))
                        return "nanos: integer expected";
                return null;
            };

            /**
             * Creates a Timestamp message from a plain object. Also converts values to their respective internal types.
             * @function fromObject
             * @memberof google.protobuf.Timestamp
             * @static
             * @param {Object.<string,*>} object Plain object
             * @returns {google.protobuf.Timestamp} Timestamp
             */
            Timestamp.fromObject = function fromObject(object) {
                if (object instanceof $root.google.protobuf.Timestamp)
                    return object;
                let message = new $root.google.protobuf.Timestamp();
                if (object.seconds != null)
                    if ($util.Long)
                        (message.seconds = $util.Long.fromValue(object.seconds)).unsigned = false;
                    else if (typeof object.seconds === "string")
                        message.seconds = parseInt(object.seconds, 10);
                    else if (typeof object.seconds === "number")
                        message.seconds = object.seconds;
                    else if (typeof object.seconds === "object")
                        message.seconds = new $util.LongBits(object.seconds.low >>> 0, object.seconds.high >>> 0).toNumber();
                if (object.nanos != null)
                    message.nanos = object.nanos | 0;
                return message;
            };

            /**
             * Creates a plain object from a Timestamp message. Also converts values to other types if specified.
             * @function toObject
             * @memberof google.protobuf.Timestamp
             * @static
             * @param {google.protobuf.Timestamp} message Timestamp
             * @param {$protobuf.IConversionOptions} [options] Conversion options
             * @returns {Object.<string,*>} Plain object
             */
            Timestamp.toObject = function toObject(message, options) {
                if (!options)
                    options = {};
                let object = {};
                if (options.defaults) {
                    if ($util.Long) {
                        let long = new $util.Long(0, 0, false);
                        object.seconds = options.longs === String ? long.toString() : options.longs === Number ? long.toNumber() : long;
                    } else
                        object.seconds = options.longs === String ? "0" : 0;
                    object.nanos = 0;
                }
                if (message.seconds != null && message.hasOwnProperty("seconds"))
                    if (typeof message.seconds === "number")
                        object.seconds = options.longs === String ? String(message.seconds) : message.seconds;
                    else
                        object.seconds = options.longs === String ? $util.Long.prototype.toString.call(message.seconds) : options.longs === Number ? new $util.LongBits(message.seconds.low >>> 0, message.seconds.high >>> 0).toNumber() : message.seconds;
                if (message.nanos != null && message.hasOwnProperty("nanos"))
                    object.nanos = message.nanos;
                return object;
            };

            /**
             * Converts this Timestamp to JSON.
             * @function toJSON
             * @memberof google.protobuf.Timestamp
             * @instance
             * @returns {Object.<string,*>} JSON object
             */
            Timestamp.prototype.toJSON = function toJSON() {
                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
            };

            /**
             * Gets the default type url for Timestamp
             * @function getTypeUrl
             * @memberof google.protobuf.Timestamp
             * @static
             * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
             * @returns {string} The default type url
             */
            Timestamp.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                if (typeUrlPrefix === undefined) {
                    typeUrlPrefix = "type.googleapis.com";
                }
                return typeUrlPrefix + "/google.protobuf.Timestamp";
            };

            return Timestamp;
        })();

        return protobuf;
    })();

    return google;
})();

export { $root as default };
