// "null import" so we can get the wasm execution environment in here
// noinspection ES6UnusedImports
import * as _ from './wasm/wasm_exec.js?inline'

import wasmUrl from './wasm/lib.wasm'

if (!WebAssembly.instantiateStreaming) {
  // polyfill
  WebAssembly.instantiateStreaming = async (resp, importObject) => {
    const source = await (await resp).arrayBuffer();
    return await WebAssembly.instantiate(source, importObject);
  };
}

const go = new Go();
let oldLog = console.log;
// send each line of output to the main thread
console.log = (line) => { postMessage({
  message: line
}); };

let mod, inst;

WebAssembly.instantiateStreaming(fetch(wasmUrl), go.importObject).then(
    async (result) => {
      mod = result.module;
      inst = result.instance;
      
      const waDone = go.run(inst)

      // critically, go seems to fail to bind to this if it is already declared
      // at least in development?
      // let myListener = function (data) {}

      addEventListener('message', async (e) => {
        // noinspection JSUnresolvedReference
        if (!myListener) {
          oldLog("WASM listener callback is still null")
        } else {
          // noinspection JSUnresolvedReference
          myListener(e.data)
        }
      })

      await waDone;
    }
);
